mtype = { msg, ack };

chan to_sndr = [2] of { mtype, bit, int };
chan to_rcvr = [2] of { mtype, bit, int };

inline risky_sending(channel, type, tag, val)
{
  if
    :: channel!type(tag, val)
    :: channel!type(tag, val); channel!type(tag, val)
    :: else
  fi
}

active proctype Sender()
{
  bit seq_out, seq_in;
  int next_msg;

  /* obtain first message */
  do
    :: risky_sending(to_rcvr, msg, seq_out, next_msg) ->
       to_sndr?ack(seq_in, 0);
       if
         :: seq_in == seq_out ->
            /* obtain new message */
            seq_out = 1 - seq_out;
            next_msg++
         :: else
       fi
  od
}

active proctype Receiver()
{
  bit seq_in;
  int received;

  do
    :: to_rcvr?msg(seq_in, received) ->
       risky_sending(to_sndr, ack, seq_in, 0)
  od
}
