/*
 * Le Lann, Chang and Roberts leader election algorithm for a ring of
 * processes
 */

#define N 5
#define BUFSIZE 10

mtype = { candidate, leader };
chan c[N] = [BUFSIZE] of { mtype, byte };

/* NB: show is a keyword which only serves to determine
   which variables should be tracked and included 
   in message sequence chart displays in the Xspin tool.
*/ 

byte num_leaders = 0;

proctype node(chan prev, next; byte mynumber)
{
  show byte num;
  show byte the_leader;
  next!candidate(mynumber);
  do
    :: prev?candidate(num) ->
       if
         :: num > mynumber ->
            next!candidate(num)
         :: num == mynumber ->
            num_leaders++;
            next!leader(mynumber)
         :: else
       fi
    :: prev?leader(the_leader) ->
       if
         :: the_leader > mynumber ->
            next!leader(the_leader);
            break
         :: else ->
            break
       fi
  od
}


init {
  byte proc;
  byte i;
  atomic {
    proc = 1;
    i = 
    do 
      :: 1 -> i++ 
      :: 1 -> break 
    od; 
    i = i % N;
    do
      :: proc <= N ->
         run node(c[proc-1], c[proc % N], (N+i-proc)%N+1);
         proc++
      :: proc > N ->
         break
    od
  }
}
