mtype = { msgA, msgB, ack };

chan to_sndr = [2] of { mtype, bit };
chan to_rcvr = [2] of { mtype, bit };

/*
#define l0	_last==0
#define l1	_last==1
#define l Sender:loss 
#define recA	(Sender@new_msg && Sender:msg == msgA)
#define sentA	(Sender@sent && Sender:msg == msgA)
#define sentB	(Sender@sent && Sender:msg == msgB)
#define recB	(Sender@new_msg && Receiver:msg == msgB)

Response to Impulse:
([]<> l0 && []<> l1 && []<>!l) -> [](sentA -> <> recvA)

Absence of Unsolicited Response:
<> recA -> (!recA  U sentA) 

FIFO:
(<> sentB -> (!sentB  U sentA)) -> (<> recB -> (!recB U recA)) 
*/

inline risky_sending(channel, type, tag)
{
  if
    :: channel!type(tag);
       loss = false
    :: loss = true;
  fi
}

active proctype Sender()
{
  bit seq_out, seq_in;
  mtype msg = msgB;
  bool loss;

  /* obtain first message */
  do
    :: risky_sending(to_rcvr,msg,seq_out) ->
sent:  to_sndr?ack(seq_in);
       if
         :: seq_in == seq_out ->
new_msg:    /* obtain new message */
            if
              :: msg = msgA;
              :: msg = msgB;
            fi;
            seq_out = 1 - seq_out;
         :: else
       fi
  od
}

active proctype Receiver()
{
  bit seq_in = 1;
  mtype msg;

  do
    :: to_rcvr?msg(seq_in)
    :: to_sndr!ack(seq_in)
  od
}
