/*
 * Le Lann, Chang and Roberts leader election algorithm for a ring of
 * processes
 */

#define N 5
#define BUFSIZE 10

mtype = { candidate, leader };
chan c[N] = [BUFSIZE] of { mtype, byte };

byte num_leaders = 0;

ltl p1	{ ![] (num_leaders == 0) }
ltl p2	{ <> (num_leaders > 0) }
ltl p3	{ [] (num_leaders == 0 U num_leaders == 1) }
ltl p4	{ <>[] (num_leaders == 1) }

proctype node(chan prev, next)
{
  byte num;
  byte the_leader;
  byte mynumber = _pid;
  assert(mynumber > 0);
  next!candidate(mynumber);
  do
    :: prev?candidate(num) ->
       if
         :: num > mynumber ->
            next!candidate(num)
         :: num == mynumber ->
            num_leaders++;
            the_leader = mynumber;
            next!leader(mynumber)
         :: else
       fi
    :: prev?leader(the_leader) ->
       if
         :: the_leader >= mynumber ->
            next!leader(the_leader);
            break
         :: the_leader < mynumber ->
            assert(false)
         :: else ->
            break
       fi
  od;
}

init {
  bool done[5];
  atomic {
    do
      :: !done[0] -> run node(c[4], c[1]); done[0] = true
      :: !done[1] -> run node(c[0], c[2]); done[1] = true
      :: !done[2] -> run node(c[1], c[3]); done[2] = true
      :: !done[3] -> run node(c[2], c[4]); done[3] = true
      :: !done[4] -> run node(c[3], c[0]); done[4] = true
      :: else -> break
    od
  }
}
